## frama-c 20130601+fluorine3+dfsg

=== Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2013                                               #
#    CEA (Commissariat  l'nergie atomique et aux nergies              #
#         alternatives)                                                  #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version 2.1                 #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# This file is the main makefile of Frama-C.

FRAMAC_SRC=.
MAKECONFIG_DIR=share

include share/Makefile.common

###################
# Frama-C Version #
###################

VERSION=$(shell $(SED) -e 's/\\(.*\\)/\\1/' VERSION)

ifeq ($(findstring +dev,$(VERSION)),+dev)
DEVELOPMENT=yes
else
DEVELOPMENT=no
endif

###########################
# Global plugin variables #
###########################

# the directory where compiled plugin files are stored
PLUGIN_LIB_DIR	= lib/plugins
PLUGIN_GUI_LIB_DIR= lib/plugins/gui

# the directory where the other Makefiles are
FRAMAC_SHARE	= share

# set it to yes to tell Makefile.dynamic than we come from here
FRAMAC_MAKE	=yes

# Shared lists between Makefile.plugin and Makefile :
# initialized them as "simply extended variables" (with :=)
# for a correct behavior of += (see section 6.6 of GNU Make manual)
PLUGIN_LIST	:=
PLUGIN_DYN_EXISTS:="no"
PLUGIN_DYN_LIST :=
PLUGIN_CMO_LIST	:=
PLUGIN_CMX_LIST	:=
PLUGIN_DYN_CMO_LIST :=
PLUGIN_DYN_CMX_LIST :=
PLUGIN_INTERNAL_CMO_LIST:=
PLUGIN_INTERNAL_CMX_LIST:=
PLUGIN_DEP_GUI_CMO_LIST:=
PLUGIN_DEP_GUI_CMX_LIST:=
PLUGIN_GUI_CMO_LIST:=
PLUGIN_GUI_CMX_LIST:=
PLUGIN_DYN_DEP_GUI_CMO_LIST:=
PLUGIN_DYN_DEP_GUI_CMX_LIST:=
PLUGIN_DYN_GUI_CMO_LIST :=
PLUGIN_DYN_GUI_CMX_LIST :=
PLUGIN_TYPES_CMO_LIST :=
PLUGIN_TYPES_CMX_LIST :=
PLUGIN_DEP_LIST:=
PLUGIN_DOC_LIST :=
PLUGIN_DOC_DIRS :=
PLUGIN_DISTRIBUTED_LIST:=
PLUGIN_DIST_TARGET_LIST:=
PLUGIN_DIST_DOC_LIST:=
PLUGIN_BIN_DOC_LIST:=
PLUGIN_DIST_EXTERNAL_LIST:=
PLUGIN_TESTS_LIST:=
PLUGIN_DISTRIBUTED_NAME_LIST:=

CEA_WP:=

###############################
# Additional global variables #
###############################

# put here any config option for the binary distribution outside of
# plugins
CONFIG_DISTRIB_BIN:=

# additional compilation targets for 'make all'.
# cannot be delayed after 'make all'
EXTRAS	= ptests

# Directories containing some source code
SRC_DIRS= ptests $(PLUGIN_LIB_DIR)

# Directory containing source code documentation
DOC_DIR	= doc/code

# Source files to document
MODULES_TODOC=

# Directories containing some source code
SRC_DIRS+= $(FRAMAC_SRC_DIRS)

# Directories to include when compiling
INCLUDES=$(addprefix -I , $(FRAMAC_SRC_DIRS)) -I $(PLUGIN_LIB_DIR) -I lib

# Directories to include for ocamldep
# Remove -I +.* and -I C:/absolute/win/path 
INCLUDES_FOR_OCAMLDEP= $(shell echo $(INCLUDES) $(GUI_INCLUDES) | $(SED) -e "s/-I *.:[^ ]*//g" -e "s/-I *+[^ ]*//g" -e "s|-I *$(LABLGTK_PATH)[^ ]*||g")

# Ocamldep flags
DEP_FLAGS= $(INCLUDES_FOR_OCAMLDEP)

# Files for which dependencies are computed
FILES_FOR_OCAMLDEP+=$(PLUGIN_LIB_DIR)/*.mli \
		$(addsuffix /*.mli, $(UNPACKED_DIRS)) \
		$(addsuffix /*.ml, $(UNPACKED_DIRS))

# Flags to use by ocamlc and ocamlopt
ifeq ($(DEVELOPMENT),yes)
ifeq ($(HAS_OCAML312),yes)
ifeq ($(WARN_ERROR_ALL),yes)
DEV_FLAGS=$(FLAGS) -warn-error +a
else
DEV_FLAGS=$(FLAGS) -warn-error +a-32-33-34-35-36-37-38-39
endif #WARN_ERROR_ALL
else
DEV_FLAGS=$(FLAGS) -warn-error A
endif #HAS_OCAML312
else
DEV_FLAGS=$(FLAGS)
endif #DEVELOPMENT

BFLAGS	= $(DEV_FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_BYTE) \
	  $(OCAMLVIZ_COMPILER_BYTE) $(OUNIT_COMPILER_BYTE)
OFLAGS	= $(DEV_FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_OPT) \
	  $(GPROFOPT) $(OCAMLVIZ_COMPILER_OPT) $(OUNIT_COMPILER_OPT) -compact

BLINKFLAGS += $(BFLAGS) -linkall -custom
OLINKFLAGS += $(OFLAGS) -linkall

DOC_FLAGS= -colorize-code -stars -inv-merge-ml-mli -m A -hide-warnings \
	$(INCLUDES) $(GUI_INCLUDES)

# Libraries generated by Frama-C
GEN_BYTE_LIBS=
GEN_OPT_LIBS=

# Libraries used in Frama-C
EXTRA_OPT_LIBS:=
BYTE_LIBS = nums.cma unix.cma bigarray.cma str.cma dynlink.cma \
	$(GEN_BYTE_LIBS)
OPT_LIBS = nums.cmxa unix.cmxa bigarray.cmxa str.cmxa $(EXTRA_OPT_LIBS)

ifeq ("$(NATIVE_DYNLINK)","yes")
OPT_LIBS+= dynlink.cmxa
endif

OPT_LIBS+= $(GEN_OPT_LIBS)

ICONS:= $(addprefix share/, \
		frama-c.ico frama-c.gif unmark.png )

FEEDBACK_ICONS:= $(addprefix share/feedback/, \
		never_tried.png \
		unknown.png \
		surely_valid.png \
		surely_invalid.png \
		considered_valid.png \
		valid_under_hyp.png \
		invalid_under_hyp.png \
		invalid_but_dead.png \
		unknown_but_dead.png \
		valid_but_dead.png \
		inconsistent.png \
		switch-on.png \
		switch-off.png )

ROOT_LIBC_DIR:= share/libc
LIBC_SUBDIRS:= . sys netinet linux net arpa
LIBC_DIR:= $(addprefix $(ROOT_LIBC_DIR)/, $(LIBC_SUBDIRS))
FREE_LIBC:= \
	share/*.h share/*.c \
	$(addsuffix /*.h, $(LIBC_DIR)) \
	$(ROOT_LIBC_DIR)/./__fc_builtin_for_normalization.i \
NONFREE_LIBC:= $(addsuffix /*.[ci], $(LIBC_DIR))

# Kernel files to be included in the distribution.
# Plug-ins should use PLUGIN_DISTRIB_EXTERNAL if they export something else
# than *.ml* files in their directory.
# NB: configure for the distribution is generated in the distrib directory
# itself, rather than copied: otherwise, it could include references to
# non-distributed plug-ins.
DISTRIB_FILES:= cil/*/*.ml* cil/*/*.in        				\
      $(filter-out cil/src/frontc/cparser.ml cil/src/frontc/cparser.mli \
          cil/src/logic/logic_lexer.ml cil/src/logic/logic_parser.mli   \
          cil/src/logic/logic_parser.ml cil/src/frontc/clexer.ml        \
          cil/src/logic/logic_preprocess.ml,                            \
	  $(wildcard cil/src/*/*.ml*))                                  \
      bin/oxygen2fluorine.sh						\
      share/frama-c.WIN32.rc share/frama-c.Unix.rc                      \
      $(ICONS) $(FEEDBACK_ICONS)			 		\
      man/frama-c.1 doc/manuals/*.pdf doc/README			\
      doc/code/docgen_*.ml						\
      doc/code/*.css doc/code/intro_plugin.txt				\
      doc/code/intro_plugin_D_and_S.txt                                 \
      doc/code/intro_plugin_default.txt                                 \
      doc/code/intro_kernel_plugin.txt doc/code/intro_occurrence.txt	\
      doc/code/intro_pdg.txt doc/code/intro_scope.txt			\
      doc/code/intro_slicing.txt doc/code/intro_sparecode.txt		\
      doc/code/intro_wp.txt doc/code/toc_head.htm			\
      doc/code/toc_tail.htm                                             \
      doc/code/print_api/*.ml* doc/code/print_api/Makefile              \
      tests/*/*.c tests/*/*.i tests/*/*.h tests/*/*.ml			\
      $(filter-out ptests/ptests_config.ml, $(wildcard ptests/*.ml*))   \
      configure.in Makefile                      			\
      share/Makefile.plugin share/Makefile.dynamic			\
      share/Makefile.dynamic_config.internal				\
      share/Makefile.dynamic_config.external Changelog config.h.in	\
      VERSION licenses/* 						\
      $(FREE_LIBC)                                                      \
      share/acsl.el share/configure.ac					\
      share/Makefile.config.in share/Makefile.common			\
      share/Makefile.plugin share/Makefile.dynamic			\
      share/Makefile.dynamic_config.external				\
      share/Makefile.dynamic_config.internal		   		\
      $(filter-out src/kernel/config.ml, $(wildcard src/kernel/*.ml*))  \
      external/hptmap.ml* external/unmarshal*.ml* external/unz.ml*      \
      external/sysutil.ml* \
      src/ai/*.ml* src/buckx/*.ml*				 	\
      src/buckx/*.c src/gui/*.ml* src/logic/*.ml*                       \
      $(filter-out src/lib/integer.ml                                   \
         src/lib/dynlink_common_interface.ml,				\
	$(wildcard src/lib/*.ml*)) 					\
      src/memory_state/*.ml* src/misc/*.ml* src/project/*.ml*		\
      src/printer/*.ml* src/toplevel/toplevel_config.ml src/type/*.ml*  \
      bin/sed_get_make_major bin/sed_get_make_minor                     \
      INSTALL INSTALL_WITH_WHY .make-clean	                        \
      .make-clean-stamp .make-ocamlgraph-stamp .force-reconfigure

# files that are needed to compile API documentation of external plugins
DOC_GEN_FILES:=$(addprefix doc/code/, \
	*.css intro_plugin.txt intro_kernel_plugin.txt \
	intro_plugin_default.txt intro_plugin_D_and_S \
	kernel-doc.ocamldoc \
	docgen_*.ml docgen.cm* *.htm)

################
# Main targets #
################

ifneq ($(ENABLE_GUI),no)
ifeq ($(HAS_LABLGTK),yes)
EXTRAS	+= gui
endif
endif

all:: byte $(OCAMLBEST) $(EXTRAS)

.PHONY: top opt byte dist bdist archclean rebuild
top: bin/toplevel.top$(EXE)
	$(MAKE) install-kernel-byte FRAMAC_LIBDIR=lib/fc

byte:: bin/toplevel.byte$(EXE) \
      share/Makefile.dynamic_config share/Makefile.kernel
	$(MAKE) install-kernel-byte FRAMAC_LIBDIR=lib/fc

opt:: bin/toplevel.opt$(EXE) \
     share/Makefile.dynamic_config share/Makefile.kernel
	$(MAKE) install-kernel-opt FRAMAC_LIBDIR=lib/fc

dist: clean
	$(QUIET_MAKE) OPTIM="-unsafe -noassert" DEBUG="" all

bdist: clean
	$(QUIET_MAKE) OPTIM="-unsafe -noassert" DEBUG="" byte

ifneq ("$(OCAMLGRAPH_LOCAL)","")
archclean: clean
	$(MAKE) -C $(OCAMLGRAPH_LOCAL) distclean
	cd $(OCAMLGRAPH_LOCAL) ; ./configure

rebuild: archclean
	$(MAKE) -C $(OCAMLGRAPH_LOCAL)
	$(QUIET_MAKE) all
else
archclean: clean

rebuild: archclean
	$(QUIET_MAKE) all
endif

############
# Coverage #
############

USE_COVERAGE_TOOL=no
ifeq ($(USE_COVERAGE_TOOL),yes)
COVERAGE_PATH=.
COVERAGE_PREPRO=camlp4o -no_quot -filter $(COVERAGE_PATH)/coverage_filter.cmo
COVERAGE_COMPILER_BYTE=-I $(COVERAGE_PATH) -pp "$(COVERAGE_PREPRO)"
COVERAGE_COMPILER_OPT=-I $(COVERAGE_PATH) -pp "$(COVERAGE_PREPRO)"
COVERAGE_LIB_BYTE=coverage.cma
COVERAGE_LIB_OPT=coverage.cmxa
endif

INCLUDES+=$(COVERAGE_COMPILER_BYTE)
GEN_BYTE_LIBS+=$(COVERAGE_LIB_BYTE)
GEN_OPT_LIBS+=$(COVERAGE_LIB_OPT)
SRC_DIRS+=$(COVERAGE_PATH)

########################
# Ocamlviz (profiling) #
########################

# To use OCamlviz you need to fix its makefile :-(
# In $(OCAMLVIZ_PATH)/Makefile.in change the line
# OCAMLVIZCMO = $(PROTOCOLCMO) src/monitor_impl.cmo src/ocamlviz.cmo src/ocamlviz_threads.cmo
# into
# OCAMLVIZCMO = $(PROTOCOLCMO) src/monitor_impl.cmo src/ocamlviz.cmo
# and
# cp -f src/ocamlviz.mli src/ocamlviz.cmi src/ocamlviz_threads.cmi $(OCAMLLIB)
# into
# cp -f src/ocamlviz.mli src/ocamlviz.cmi $(OCAMLLIB)
#
# Then run "./configure && make && make install" in $(OCAMLVIZ_PATH)
# Only one instance of Frama-C can be launched at a time when Ocamlviz is on.
USE_OCAMLVIZ_TOOL=no
ifeq ($(USE_OCAMLVIZ_TOOL),yes)
OCAMLVIZ_PATH=~/src/ocamlviz
OCAMLVIZ_COMPILER_BYTE=-I $(OCAMLVIZ_PATH)/src # -pp "camlp4 pa_o.cmo str.cma $(OCAMLVIZ_PATH)/camlp4/pa_ocamlviz.cmo pr_o.cmo"
# Seems really broken and generates fatal warnings
OCAMLVIZ_COMPILER_OPT=-I $(OCAMLVIZ_PATH)/src
OCAMLVIZ_LIB_BYTE=~/lib/ocaml/libocamlviz.cma
