=== debian/changelog ===
frama-c (20130601+fluorine3+dfsg-2build1) trusty; urgency=medium

  * Rebuild for ocaml-4.01.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Dec 2013 22:01:50 +0000

frama-c (20130601+fluorine3+dfsg-2) unstable; urgency=low

  * Team upload
  * debian/patches:
    + Fix compilation with OCaml 4.01.0 (Closes: #731637)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 08 Dec 2013 12:25:21 +0100

frama-c (20130601+fluorine3+dfsg-1) unstable; urgency=low

  * New upstream release (Closes: #714124)
    - Remove 0001-Add-ocamlgraph-to-DYN_-O-B-LINKFLAGS.patch, fixed
      upstream
    - Remove 0002-Accept-ocamlgraph-1.8.patch, fixed upstream
    - Remove 0006-Patchlevel2-for-Nitrogen-20111001.patch, integrated
    - Add 0004-Fix-auto-detection-of-ocaml-zarith.patch
    - Require ocamlgraph (>= 1.8.3~) on build.
  * Add libzarith-ocaml-dev to Build-Depends.
  * Add autoconf to Build-Depends.
  * Call dh_ocaml with --nodefined-map=frama-c-base:Big_int_Z,Z,Q, modules
    already declared by ocaml-zarith.

 -- Mehdi Dogguy <mehdi@debian.org>  Mon, 25 Nov 2013 15:02:35 +0100
