## frama-c 20140301+neon+dfsg

=== Makefile ===
--- 
+++ 
@@ -2,8 +2,8 @@
 #                                                                        #
 #  This file is part of Frama-C.                                         #
 #                                                                        #
-#  Copyright (C) 2007-2013                                               #
-#    CEA (Commissariat  l'nergie atomique et aux nergies              #
+#  Copyright (C) 2007-2014                                               #
+#    CEA (Commissariat à l'énergie atomique et aux énergies              #
 #         alternatives)                                                  #
 #                                                                        #
 #  you can redistribute it and/or modify it under the terms of the GNU   #
@@ -87,6 +87,8 @@
 PLUGIN_DISTRIBUTED_NAME_LIST:=
 
 CEA_WP:=
+UNMODIFIED_WHY3:=
+MODIFIED_WHY3:=
 
 ###############################
 # Additional global variables #
@@ -117,10 +119,12 @@
 
 # Directories to include for ocamldep
 # Remove -I +.* and -I C:/absolute/win/path 
-INCLUDES_FOR_OCAMLDEP= $(shell echo $(INCLUDES) $(GUI_INCLUDES) | $(SED) -e "s/-I *.:[^ ]*//g" -e "s/-I *+[^ ]*//g" -e "s|-I *$(LABLGTK_PATH)[^ ]*||g")
+INCLUDES_FOR_OCAMLDEP=$(addprefix -I , $(FRAMAC_SRC_DIRS)) \
+                      -I $(PLUGIN_LIB_DIR) -I lib
 
 # Ocamldep flags
-DEP_FLAGS= $(INCLUDES_FOR_OCAMLDEP)
+DEP_FLAGS= $(shell echo $(INCLUDES_FOR_OCAMLDEP) \
+             | $(SED) -e "s/-I *.:[^ ]*//g" -e "s/-I *+[^ ]*//g")
 
 # Files for which dependencies are computed
 FILES_FOR_OCAMLDEP+=$(PLUGIN_LIB_DIR)/*.mli \
@@ -129,15 +133,11 @@
 
 # Flags to use by ocamlc and ocamlopt
 ifeq ($(DEVELOPMENT),yes)
-ifeq ($(HAS_OCAML312),yes)
 ifeq ($(WARN_ERROR_ALL),yes)
 DEV_FLAGS=$(FLAGS) -warn-error +a
 else
 DEV_FLAGS=$(FLAGS) -warn-error +a-32-33-34-35-36-37-38-39
 endif #WARN_ERROR_ALL
-else
-DEV_FLAGS=$(FLAGS) -warn-error A
-endif #HAS_OCAML312
 else
 DEV_FLAGS=$(FLAGS)
 endif #DEVELOPMENT
@@ -193,8 +193,39 @@
 FREE_LIBC:= \
 	share/*.h share/*.c \
 	$(addsuffix /*.h, $(LIBC_DIR)) \
-	$(ROOT_LIBC_DIR)/./__fc_builtin_for_normalization.i \
+	$(ROOT_LIBC_DIR)/./__fc_builtin_for_normalization.i
+
 NONFREE_LIBC:= $(addsuffix /*.[ci], $(LIBC_DIR))
+
+
+# Checks that all .h can be included multiple times.
+ALL_LIBC_HEADERS:=$(wildcard share/*.h $(addsuffix /*.h, $(LIBC_DIR)))
+
+check-libc: bin/toplevel.$(OCAMLBEST)$(EXE)
+	@echo "checking libc..."; \
+	 EXIT_VALUE=0; \
+	 for file in $(ALL_LIBC_HEADERS); do \
+	   echo "#include \"$$file\"" > check-libc.c; \
+	   echo "#include \"$$file\"" >> check-libc.c; \
+	   FRAMAC_SHARE=share bin/toplevel.$(OCAMLBEST)$(EXE) \
+           -cpp-extra-args="-Ishare/libc -nostdinc" check-libc.c \
+               > $$(basename $$file .h).log 2>&1; \
+	   if test $$? -ne 0; then \
+	     if grep -q -e '#error "Frama-C:' $$file; then : ; \
+	     else \
+	       echo "$$file cannot be included twice. \
+Output is in $$(basename $$file .h).log"; \
+	       EXIT_VALUE=1; \
+	     fi; \
+	   else \
+	     rm $$(basename $$file .h).log; \
+           fi; \
+	 done; \
+	 rm check-libc.c; \
+	 exit $$EXIT_VALUE
+
+clean-check-libc:
+	$(RM) *.log
 
 # Kernel files to be included in the distribution.
 # Plug-ins should use PLUGIN_DISTRIB_EXTERNAL if they export something else
@@ -208,7 +239,7 @@
           cil/src/logic/logic_parser.ml cil/src/frontc/clexer.ml        \
           cil/src/logic/logic_preprocess.ml,                            \
 	  $(wildcard cil/src/*/*.ml*))                                  \
-      bin/oxygen2fluorine.sh						\
+      bin/*2*.sh							\
       share/frama-c.WIN32.rc share/frama-c.Unix.rc                      \
       $(ICONS) $(FEEDBACK_ICONS)			 		\
       man/frama-c.1 doc/manuals/*.pdf doc/README			\
@@ -231,13 +262,14 @@
       VERSION licenses/* 						\
       $(FREE_LIBC)                                                      \
       share/acsl.el share/configure.ac					\
-      share/Makefile.config.in share/Makefile.common			\
+      share/Makefile.config.in share/Makefile.common                    \
+      share/Makefile.generic			                        \
       share/Makefile.plugin share/Makefile.dynamic			\
       share/Makefile.dynamic_config.external				\
       share/Makefile.dynamic_config.internal		   		\
       $(filter-out src/kernel/config.ml, $(wildcard src/kernel/*.ml*))  \
       external/hptmap.ml* external/unmarshal*.ml* external/unz.ml*      \
-      external/sysutil.ml* \
+      external/sysutil.ml* 			\
       src/ai/*.ml* src/buckx/*.ml*				 	\
       src/buckx/*.c src/gui/*.ml* src/logic/*.ml*                       \
       $(filter-out src/lib/integer.ml                                   \
@@ -294,52 +326,26 @@
 rebuild: archclean
 	$(MAKE) -C $(OCAMLGRAPH_LOCAL)
 	$(QUIET_MAKE) all
+
+OCAMLGRAPH_MERLIN="S `readlink -f $(OCAMLGRAPH_LOCAL)`\\nB `readlink -f $(OCAMLGRAPH_LOCAL)`"
 else
 archclean: clean
 
 rebuild: archclean
 	$(QUIET_MAKE) all
-endif
+
+OCAMLGRAPH_MERLIN="PKG ocamlgraph"
+endif
+
+.PHONY:merlin
+merlin:
+#create Merlin file
+	find `echo "src cil external" | xargs -n 1 -d ' ' readlink -f` \( -name .svn -name tests -o -name doc -o -name result -o -name -o -name oracle -o -name "*.cache" \) -prune -o \( -type d -printf "B %p\nS %p\n"  \) > .merlin
+	echo $(OCAMLGRAPH_MERLIN) >> .merlin
+	echo "PKG zarith" >> .merlin
 
 ############
 # Coverage #
 ############
 
 USE_COVERAGE_TOOL=no
-ifeq ($(USE_COVERAGE_TOOL),yes)
-COVERAGE_PATH=.
-COVERAGE_PREPRO=camlp4o -no_quot -filter $(COVERAGE_PATH)/coverage_filter.cmo
-COVERAGE_COMPILER_BYTE=-I $(COVERAGE_PATH) -pp "$(COVERAGE_PREPRO)"
-COVERAGE_COMPILER_OPT=-I $(COVERAGE_PATH) -pp "$(COVERAGE_PREPRO)"
-COVERAGE_LIB_BYTE=coverage.cma
-COVERAGE_LIB_OPT=coverage.cmxa
-endif
-
-INCLUDES+=$(COVERAGE_COMPILER_BYTE)
-GEN_BYTE_LIBS+=$(COVERAGE_LIB_BYTE)
-GEN_OPT_LIBS+=$(COVERAGE_LIB_OPT)
-SRC_DIRS+=$(COVERAGE_PATH)
-
-########################
-# Ocamlviz (profiling) #
-########################
-
-# To use OCamlviz you need to fix its makefile :-(
-# In $(OCAMLVIZ_PATH)/Makefile.in change the line
-# OCAMLVIZCMO = $(PROTOCOLCMO) src/monitor_impl.cmo src/ocamlviz.cmo src/ocamlviz_threads.cmo
-# into
-# OCAMLVIZCMO = $(PROTOCOLCMO) src/monitor_impl.cmo src/ocamlviz.cmo
-# and
-# cp -f src/ocamlviz.mli src/ocamlviz.cmi src/ocamlviz_threads.cmi $(OCAMLLIB)
-# into
-# cp -f src/ocamlviz.mli src/ocamlviz.cmi $(OCAMLLIB)
-#
-# Then run "./configure && make && make install" in $(OCAMLVIZ_PATH)
-# Only one instance of Frama-C can be launched at a time when Ocamlviz is on.
-USE_OCAMLVIZ_TOOL=no
-ifeq ($(USE_OCAMLVIZ_TOOL),yes)
-OCAMLVIZ_PATH=~/src/ocamlviz
-OCAMLVIZ_COMPILER_BYTE=-I $(OCAMLVIZ_PATH)/src # -pp "camlp4 pa_o.cmo str.cma $(OCAMLVIZ_PATH)/camlp4/pa_ocamlviz.cmo pr_o.cmo"
-# Seems really broken and generates fatal warnings
-OCAMLVIZ_COMPILER_OPT=-I $(OCAMLVIZ_PATH)/src
-OCAMLVIZ_LIB_BYTE=~/lib/ocaml/libocamlviz.cma
