=== src/dummy/hello_world/Makefile ===
--- 
+++ 
@@ -2,8 +2,8 @@
 #                                                                        #
 #  This file is part of Frama-C.                                         #
 #                                                                        #
-#  Copyright (C) 2007-2013                                               #
-#    CEA (Commissariat  l'nergie atomique et aux nergies              #
+#  Copyright (C) 2007-2014                                               #
+#    CEA (Commissariat à l'énergie atomique et aux énergies              #
 #         alternatives)                                                  #
 #                                                                        #
 #  you can redistribute it and/or modify it under the terms of the GNU   #
