=== debian/changelog ===
frama-c (20140301+neon+dfsg-3) unstable; urgency=medium

  * Add a call to autoconf prior to configure.

 -- Mehdi Dogguy <mehdi@debian.org>  Tue, 29 Apr 2014 19:16:49 +0200

frama-c (20140301+neon+dfsg-2) unstable; urgency=medium

  * The new configure script tries to compile a test program linking
    against the OCamlgraph library. Unfortunately, upstream only tests
    the native case and fails for the bytecode case. Since, the OCamlgraph
    library is tested elsewhere, I'm adding a patch to disable that check.
    This resolves observed FTBFS on bytecode architectures (mips and mipsel).
    - Add 0005-Don-t-fail-during-the-configure-on-bytecode-architec.patch

 -- Mehdi Dogguy <mehdi@debian.org>  Mon, 28 Apr 2014 21:28:44 +0200

frama-c (20140301+neon+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Refresh patches
    - Remove 0005-Fix-compilation-with-OCaml-4.01.0.patch
    - Add 0004-Port-to-OCamlgraph-1.8.5.patch (Closes: #746091)
  * Bump build-dependency of Ocamlgraph to 1.8.5~.
  * Pass --enabe-zarith to configure script instead of patching it.
    - Remove 0004-Fix-auto-detection-of-ocaml-zarith.patch.

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 27 Apr 2014 21:41:47 +0200
