=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  graphviz,
  autoconf,
  libzarith-ocaml-dev,
- libocamlgraph-viewer-ocaml-dev (>> 1.8.3~),
+ libocamlgraph-viewer-ocaml-dev (>> 1.8.5~),
  liblablgtk2-gnome-ocaml-dev (>= 2.14.0+dfsg-2~),
  liblablgtksourceview2-ocaml-dev (>= 2.14.0+dfsg-2~)
 Standards-Version: 3.9.2
