=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,7 @@
 	mkdir -p lib/gui
 	touch .depend .make-clean .make-clean-stamp
 	[ ! -f src/kernel/config.ml ] || cp src/kernel/config.ml src/kernel/config.ml.debian
+	autoconf
 	./configure $(CROSS) --prefix=/usr       \
 		--mandir=\$${prefix}/share/man   \
 		--infodir=\$${prefix}/share/info \
@@ -19,6 +20,7 @@
 		--disable-impact		 \
 		--disable-security		 \
 		--enable-verbosemake             \
+		--enable-zarith="$(OCAML_STDLIB_DIR)/zarith" \
 		CFLAGS="$(CFLAGS)"               \
 		LDFLAGS="-Wl,-z,defs"
